package cn.ibizlab.businesscentral.core.base.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.businesscentral.core.base.domain.Feedback;
import cn.ibizlab.businesscentral.core.base.filter.FeedbackSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[Feedback] 服务对象接口
 */
public interface IFeedbackService extends IService<Feedback>{

    boolean update(Feedback et) ;
    void updateBatch(List<Feedback> list) ;
    boolean create(Feedback et) ;
    void createBatch(List<Feedback> list) ;
    Feedback get(String key) ;
    Feedback getDraft(Feedback et) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean checkKey(Feedback et) ;
    boolean save(Feedback et) ;
    void saveBatch(List<Feedback> list) ;
    Page<Feedback> searchDefault(FeedbackSearchContext context) ;
    List<Feedback> selectByCreatedbycontact(String contactid) ;
    void removeByCreatedbycontact(String contactid) ;
    List<Feedback> selectByCreatedonbehalfbycontact(String contactid) ;
    void removeByCreatedonbehalfbycontact(String contactid) ;
    List<Feedback> selectByTransactioncurrencyid(String transactioncurrencyid) ;
    void removeByTransactioncurrencyid(String transactioncurrencyid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<Feedback> getFeedbackByIds(List<String> ids) ;
    List<Feedback> getFeedbackByEntities(List<Feedback> entities) ;

}


